Lua_GodFurnaceItem = class("Lua_GodFurnaceItem", Lua_DisplayObject);
function Lua_GodFurnaceItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GodFurnaceItem:buildShowItem()
	self:superCall("buildShowItem");

	self.toolImg = Lua_ToolImage.new(self.content);
	self.toolImg:setDepth(5);
	self.toolImg:setCanClick(true);
end

function Lua_GodFurnaceItem:setData(data)
	self.toolImg.data = data.vo;
	if data.show_effect == 1 then
		self.toolImg:showRoundEff(true);
	end

	if data.item_id == DataCenter.godFurnaceData.id then
		local str = LanUtil.formateStr(LanUtil.getValue(144503), tostring(data.value));
		self.toolImg:showRtDesc(str, true);
	end
end

function Lua_GodFurnaceItem:setEffect()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/shenludajiang", "shenludajiang", 0, 0);
		self.effect:setScale(800, 800, 800);
		self.effect:SetRenderQueue(self.toolImg.item_bg, 5, 2);
	end
end

function Lua_GodFurnaceItem:dispose()
	if self.toolImg ~= nil then
		self.toolImg:dispose();
		self.toolImg = nil;
	end
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end

	self:superCall("dispose");
end