checkRequire("Lua_TreasureResultWindow");
Lua_GodFurnaceResultWindow = class("Lua_GodFurnaceResultWindow", Lua_TreasureResultWindow);
function Lua_GodFurnaceResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GodFurnaceResultWindow";
	self.bShowRuneChips = false;
	self.showAgain = false;
end

function Lua_GodFurnaceResultWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	if DataCenter.godFurnaceData.drawType == 0 then
		self.againBtn.label = LanUtil.getValue(121409);
		self.moneyCost = DataCenter.godFurnaceData.one_cost;
	elseif DataCenter.godFurnaceData.drawType == 1 then
		self.againBtn.label = LanUtil.getValue(121433);
		self.moneyCost = DataCenter.godFurnaceData.ten_cost;
	elseif DataCenter.godFurnaceData.drawType == 2 then
		self:setSubBtnPos(0, -207);
		self:setAgainBtnState(false);
	end

	self:addLuaEvent("UPDATE_GOD_FURNACE_RESULT", self, self.onGodFurnaceResult);
end

function Lua_GodFurnaceResultWindow:onGodFurnaceResult(msg)
	if msg ~= nil then
		local list = msg.rewards; -- 获得的道具列表
		local len = #list;
		if len > 10 then
			local arr = Array();
			local val;
			for i = 1, len do 
				if list[i].id == DataCenter.godFurnaceData.id then
					val = list[i].index;
				else
					val = 0;
				end
				arr:add({itemList = list[i], val = val});
			end

			if self.dragList == nil then
				self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 800, 280));
				self.dragList:setLocation(0, -5, 0);
				self.dragList:setListCell(Lua_GodFurnaceResultItem, 145, 160, 5);
			end
			self.dragList:setLuaArrayData(arr, false);
		else
			local arr = Array();
			local rtDescArr = Array(); -- 图标右上角描述，这里用于神炉值显示
			local val;
			for i = 1, len do 
				local tvo = Lua_ToolVo.createToolVo(list[i].id);
				tvo:fromServer(list[i]);
				tvo.bShowQualityEff = true;
				arr:add(tvo);

				if list[i].id == DataCenter.godFurnaceData.id then
					val = list[i].index;
				else
					val = 0;
				end
				rtDescArr:add({ isGodFurnace = 1, val = val });
			end
			self:setShowResultData(arr, nil, rtDescArr);
		end
	end
end

function Lua_GodFurnaceResultWindow:onAgainBtnClick(go)
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.moneyCost, true, true) then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.GOD_FURNACE, DataCenter.godFurnaceData.drawType);
	end
end

function Lua_GodFurnaceResultWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_GodFurnaceResultItem = class("Lua_GodFurnaceResultItem", Lua_ListCell);
function Lua_GodFurnaceResultItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GodFurnaceResultItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setLocation(0, 25, 0)
	self.itemImage:setDepth(5);

	self.itemName = UICreate.createLabel(self.content, "", 0, -40, 360, 30, 24);
	self.itemName.pivot = UIWidget.Pivot.Center;
	self.itemName:setDepth(5);
end

function Lua_GodFurnaceResultItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.itemList.id);
	tvo:fromServer(data.itemList);
	tvo.packType = Lua_PackTypeDefine.EQUIP;
	self.itemImage.data = tvo;
	self.itemName.text = tvo.colorName;

	if data.val ~= nil and data.val ~= 0 then
		local str = LanUtil.formateStr(LanUtil.getValue(144503), tostring(data.val));
		self.itemImage:showRtDesc(str, true);
	end
end

function Lua_GodFurnaceResultItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 50, self.itemY - 10, 100, 60);
	self.itemImage:showQualityEff(showRect:containeRect(rect));
end

function Lua_GodFurnaceResultItem:dispose()
    self:superCall("dispose");
end