-- 神炉炼宝
checkRequire("Lua_ItemShowModelPanel");
checkRequire("Lua_GodFurnaceItem");
Lua_GodFurnaceWindow  = class("Lua_GodFurnaceWindow", Lua_Window);
function Lua_GodFurnaceWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GodFurnaceWindow";
	self.skinName = "GodFurnaceWindow_skin";
end

function Lua_GodFurnaceWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.moneyCost = 0;
	self.draw_flag = -1;
	self.draw_count = 0;
	self.itemArr = Array();

	self.oneBtn:addClickFuntion(self, self.onOneBtnClick);
	self.tenBtn:addClickFuntion(self, self.onTenBtnClick);
	self.helpBtn:addClickFuntion(self, self.onHelpBtnClick);

	self:addLuaEvent("UPDATE_GOD_FURNACE", self, self.updatePanelInfo);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.GOD_FURNACE);
end

function Lua_GodFurnaceWindow:updatePanelInfo()
	Lua_CommonUtil.addTimer("Lua_GodFurnaceWindow", 1, self, self.updateResidueTime);
	self:updateResidueTime();

	self.tips.text = DataCenter.godFurnaceData.help_tips;
	self.oneCostLab.text = DataCenter.godFurnaceData.one_cost;
	self.tenCostLab.text = DataCenter.godFurnaceData.ten_cost;

	local vo = DataCenter.godFurnaceData.getModelInfo;
	local bgPath = "/images/godFurnace/ui_sllb_bg_02.png";
	if vo == nil then
		local modelBg = UICreate.createImage(self.content, bgPath, -321, -1, 0, 0);
		modelBg:setDepth(1);

		if self.showModel ~= nil then
			self.showModel:dispose();
			self.showModel = nil;
		end
		self.showModel = UICreate.createUIEffect(self.content, "/mounts/gui_sevenday_money", "gui_sevenday_money", -321, -155);
		self.showModel:setRot(0, -60, 7);
		self.showModel:setScale(1.5, 1.5, 1.5);
		self.showModel:SetRenderQueue(modelBg, 5, 2, false);
		self.showModel:setRotEnable(true, -321, -1, 354, 522, 1);
	else
		local pos = DataCenter.godFurnaceData.getModelPos;
		local rot = DataCenter.godFurnaceData.getModelRot;
		local sca = DataCenter.godFurnaceData.getModelSca;
		if self.modelPanel ~= nil then
			self.modelPanel:dispose();
			self.modelPanel = nil;
		end
		self.modelPanel = Lua_ItemShowModelPanel.new(self.content, 354, 522, -321, 261, pos, rot, sca, true);
		self.modelPanel.bg:setUrl(bgPath);
		self.modelPanel:setShowData(vo);
		self.modelPanel:setDepth(5)
	end

	if DataCenter.godFurnaceData.isItemCreate == false then
		self:onCreateItem();
		DataCenter.godFurnaceData.isItemCreate = true;
	end
	self:updateProgressBar();
end

-- 创建展示道具
function Lua_GodFurnaceWindow:onCreateItem()
	local arr = DataCenter.godFurnaceData.getRewardsData;
	local item;
	for i = 1, arr:getSize() do
		item = self.itemArr[i];
		if item == nil then
			item = Lua_GodFurnaceItem.new(self["itemBg" .. i].mainContent);
			item.content.name = "Lua_GodFurnaceItem" .. i;
			if i >= 10 then
				item:setScale(1.05, 1.05);
				item:setEffect();
			end
			self.itemArr:add(item);
		end
		item:setData(arr[i]);
	end
end

function Lua_GodFurnaceWindow:updateProgressBar()
	local val;
	local open_value = DataCenter.godFurnaceData.open_value;
	local current_value = DataCenter.godFurnaceData.current_value;
	if current_value < open_value then
		if self.kailuEffet ~= nil then
			self.kailuEffet.mainContent:SetActive(false);
		end

		self.openBtn.mouseEnable = false;
		self.openBtn:removeClickFuntion(self, self.onOpenBtnClick);

		val = current_value;
		self.bar:setText("["..Lua_ColorDefine.RED_STR.."]"..current_value.."[-]".."/"..open_value);

		DataCenter.redDotData:updateRedDotVoState(22071, false);
	else
		if self.kailuEffet == nil then
			self.kailuEffet = UICreate.createUIEffect(self.content, "/effects/scsEffects/shenlukailu", "shenlukailu", 179, 15);
		else
			self.kailuEffet:setEnable(false);
			self.kailuEffet:setEnable(true);
		end
		self.kailuEffet:SetRenderQueue(self.openBtn, 10, 2);

		self.openBtn.mouseEnable = true;
		self.openBtn:addClickFuntion(self, self.onOpenBtnClick);

		val = open_value;
		self.bar:setText("["..Lua_ColorDefine.WHITE_STR.."]"..current_value.."/"..open_value);
	end
	self.bar:setMaxValue(open_value);
	self.bar:setValue(val);
end

-- 活动剩余时间
function Lua_GodFurnaceWindow:updateResidueTime()
	local leftTime = tonumber(DataCenter.godFurnaceData.end_tick) - DataCenter.roleData.serverTime;
	self.leftTimeLab.text = LanUtil.formateStr(LanUtil.getValue(146010), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		self.leftTimeLab.text = LanUtil.getValue(146011);
		Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	end
end

function Lua_GodFurnaceWindow:onOpenBtnClick()
	DataCenter.godFurnaceData.drawType = 2;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.GOD_FURNACE, 2);
end

function Lua_GodFurnaceWindow:onOneBtnClick()
	DataCenter.godFurnaceData.drawType = 0;
	self.draw_flag = 0;
	self.draw_count = 1;
	self.moneyCost = DataCenter.godFurnaceData.one_cost;
	self:checkMoney();
end

function Lua_GodFurnaceWindow:onTenBtnClick()
	DataCenter.godFurnaceData.drawType = 1;
	self.draw_flag = 1;
	self.draw_count = 10;
	self.moneyCost = DataCenter.godFurnaceData.ten_cost;
	self:checkMoney();
end

function Lua_GodFurnaceWindow:onHelpBtnClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, DataCenter.godFurnaceData.content);
end

function Lua_GodFurnaceWindow:checkMoney()
	local str = "";
	if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.moneyCost then
		str = "["..Lua_ColorDefine.RED_STR.."]"..self.moneyCost.."[-]";
		self.enoughMoney = false;
	else
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..self.moneyCost.."[-]";
		self.enoughMoney = true;
	end

	if DataCenter.neverTip:getNeverValue("Lua_GodFurnaceWindow") == true then
		if self.enoughMoney == false then
			DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.moneyCost, true, true);
		else
			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.GOD_FURNACE, self.draw_flag);
		end
		return;
	end

	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, neverTip = "Lua_GodFurnaceWindow",
	des = LanUtil.formateStr(LanUtil.getValue(144502), str, tostring(self.draw_count)), type = 1, subFun = self.onSureFun});
end

function Lua_GodFurnaceWindow:onSureFun()
	if self.enoughMoney == false then
		DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.moneyCost, true, true);
	else
		if DataCenter.godFurnaceData:checkBagPackEnough(Lua_PackData.BAG_PACK) == false then
			return;
		end
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.GOD_FURNACE, self.draw_flag);
	end
end

function Lua_GodFurnaceWindow:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	if self.showModel ~= nil then
		self.showModel:dispose();
		self.showModel = nil;
	end
	if self.modelPanel ~= nil then
		self.modelPanel:dispose();
		self.modelPanel = nil;
	end
	if self.kailuEffet ~= nil then
		self.kailuEffet:dispose();
		self.kailuEffet = nil;
	end
	self.moneyCost = 0;
	self.draw_flag = -1;
	self.draw_count = 0;
	DataCenter.godFurnaceData.isItemCreate = false;
	Lua_CommonUtil.removeTimer(self, self.updateResidueTime);

	self:superCall("dispose");
end